/*
 * FILE: $Source: /u/chestnut/ezk/kitot/advanced-os/2/RCS/esh.c,v $
 * HEADER: $Id: esh.c,v 1.10 1992/02/11 13:56:39 ezk Exp ezk $
 * REVISION HISTORY:
 * $Log: esh.c,v $
 * Revision 1.10  1992/02/11  13:56:39  ezk
 * FINAL VERSION (unless I get an extension...)
 *
 * Revision 1.9  1992/02/10  00:30:08  ezk
 * bg and & work now.  bug fixes so that status reported in "jobs" cmd
 * is correct, and also each time you hit newline.
 *
 * Revision 1.8  1992/02/09  19:01:19  ezk
 * more work on job control. can bg and stop process. some status gets
 * reported but not perfect yet.
 *
 * Revision 1.7  1992/02/09  00:22:13  ezk
 * one process in fg.  can ^C it or wait until it ends.  shell prompt
 * using PS1 if used.  can suspend a process but not bg/fg it yet.
 *
 * Revision 1.6  1992/02/07  04:53:50  ezk
 * built major jobs structures and converted code to use it.
 * basic export command.
 *
 * Revision 1.5  1992/02/06  21:50:46  ezk
 * simple variables (w/o braces) are supported and expanded, even if
 * prefeixed or postfixed by other strings or variables.
 *
 * Revision 1.4  1992/02/06  16:40:07  ezk
 * basic environment structures created and some manipulation of them (but
 * very basic.)
 *
 * Revision 1.3  1992/02/06  02:55:43  ezk
 * got stubs for all builtins.  shtrace, exit, and error working.
 *
 * Revision 1.2  1992/02/04  22:34:15  ezk
 * parses & and ; correctlly with pipelines too. builds the structures.
 * no execing yet.
 *
 *
 *
 * Main shell call.  Initialize basic things.
 * 
 * E6118y - Advanced Operating Systems.
 * Erez Zadok.
 * Columbia U.  Spring 1992.
 */

#include "process.h"

char *progname;			/* for error messages */

main(argc, argv, envp)		/* for Erez's SHell */
     int argc;
     char *argv[], *envp[];
{
#ifdef ESH_DEBUG
/*   fprintf(stderr, "%s Running...\n", argv[0]); */
  yydebug = 0;
  yy_flex_debug = 0;
#endif /* ESH_DEBUG */

  init_esh(envp);		/* initialize */
  progname = argv[0];
  each_line();

  for (;;) {			/* loop over parser */
    yyparse();
  }
}
