/*-
 * gethostid.c --
 *
 *	Replacement gethostid() for systems that don't have it or for which
 *	it is broken.
 */
#ifndef lint
static char *rcsid = "$Id: gethostid.c,v 1.4 1992/11/10 20:03:52 stolcke Exp $ ICSI (Berkeley)";
#endif /* lint */

#ifdef hpux
#include <sys/utsname.h>

/*
 * This routine maps the 4.3BSD gethostid system call onto the
 * System V utime call on systems that have a struct utsname that include
 * a system identification number (like HP-UX).
 */
int
gethostid()
{
    struct utsname name;

    if (uname(&name) < 0) {
	perror("uname");
	return -1;
    }

    return atoi(name.__idnumber);
}
#endif /* hpux */

#ifdef ultrix
#include <sys/types.h>
#include <netinet/in.h>

/*
 * Ultrix gethostid() always returns 0 unless set by hand.  It is
 * "recommended" to sethostid(ip-address), so we'll just use that.
 */
int
gethostid()
{
    struct sockaddr_in addr;

    /*
     * get_myaddress() from the RPC library gets the local IP address
     * by querying the network interface.
     */
    get_myaddress(&addr);

    return ntohl(addr.sin_addr.s_addr);
}
#endif /* ultrix */

#ifdef TEST
#include <stdio.h>

main()
{
    printf("%d\n", gethostid());
    exit(0);
}
#endif /* TEST */
